--[[----------------------------------------------------------------------------

OzDocStoreNativeMigrator.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2016 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

------------------------------------------------------------------------------]]

-- OzDocStoreMigrator
local OzDocStoreNativeMigratorImp = require 'OzDocStoreNativeMigratorImp'
local OzDocStoreMigratorUtils = require 'OzDocStoreMigratorUtils'

	-- WF.core.utils
local blonde = require 'blonde'

--==============================================================================

local OzDocStoreNativeMigrator = {}

--------------------------------------------------------------------------------

function OzDocStoreNativeMigrator.migrateDocStore( dst, src, migrationOptions, dropPreviews, restart  )

	if not migrationOptions then
		migrationOptions = "migrateOnDisk"
	end

	if not dropPreviews then
		dropPreviews = false
	end

	if not restart then
		restart = false
	end


	return OzDocStoreNativeMigratorImp:migrateDocStore( dst, src, migrationOptions, dropPreviews, restart )

end

--------------------------------------------------------------------------------

function OzDocStoreNativeMigrator.migrateDoc( doc, catalogPath, dropPreviews )

	if not dropPreviews then
		dropPreviews = false
	end

	local success, result = OzDocStoreNativeMigratorImp.migrateDoc( 
			blonde.encode( doc.serverBaseValue ),
			blonde.encode( doc.localOverlay ),
			doc._id,
			doc.docType,
			catalogPath,
			dropPreviews )
			
	if success then
		result = OzDocStoreMigratorUtils.contentFromFlattenedValue( result )
	end
	
	return success, result
	
end

--------------------------------------------------------------------------------

return OzDocStoreNativeMigrator
